
#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#include <io.h>

#define LINESIZE        64
#define C_MIN           0x30

char* obuf=(char*)malloc(65536);
int obufsize=0;

int code=0, len=0, l=0;

void putbyte(int x)
{
  code|=(x&255)<<len;
  len+=8;
  while (len>=6)
  {
    obuf[obufsize++] = C_MIN+(code&63);
    code>>=6;
    len-=6;

    l++;
    if (l>=LINESIZE)
    {
      l=0;
      obuf[obufsize++]=0x0D;
      obuf[obufsize++]=0x0A;
    }

  }
}

void main(int argc, char* argv[])
{
  if (argc!=3)
  {
    printf("syntax: com2uue infile outfile\n");
    return;
  }

  FILE*f = fopen("ldruue.bin","rb");
  assert(f!=NULL);
  int buf1size = filelength(fileno(f));
  char* buf1 = (char*)malloc(buf1size);
  fread(buf1, 1,buf1size, f);
  fclose(f);

  f = fopen(argv[1],"rb");
  assert(f!=NULL);
  int ibufsize = filelength(fileno(f));
  char* ibuf = (char*)malloc(ibufsize);
  fread(ibuf, 1,ibufsize, f);
  fclose(f);

  for (int i=buf1size-1; i>=0; i--, l++)
    if (buf1[i]==0x0A) break;

  putbyte(ibufsize);
  putbyte(ibufsize>>8);
  for (int i=0; i<ibufsize; i++)
    putbyte(ibuf[i]);
  if (len!=0) obuf[obufsize++] = C_MIN+code;

  obuf[obufsize++]=0x0D;
  obuf[obufsize++]=0x0A;

  f = fopen(argv[2],"wb");
  assert(f!=NULL);
  fwrite(buf1, 1,buf1size, f);
  fwrite(obuf, 1,obufsize, f);
  fclose(f);

}
