
#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#include <io.h>
#include "random.h"

#define LINESIZE        64
#define C_MIN           0x30
#define C_MAX           0x7E

#define notrange(x)     (((x&255)<C_MIN)||((x&255)>C_MAX)||\
                        (((x>>8)&255)<C_MIN)||(((x>>8)&255)>C_MAX))

char* obuf = (char*)malloc(8192);
int osize=0;

void crlf()
{
  if ((osize%(LINESIZE+2))>LINESIZE-4)
  {
    while ((osize%(LINESIZE+2))<LINESIZE-1)
      obuf[osize++]=0x4A; // dec dx
    obuf[osize++]=0x3D;   // cmp ax, 0A0Dh
    obuf[osize++]=0x0D;
    obuf[osize++]=0x0A;
  }
}

int a= (C_MIN<<8)+C_MIN , a0=-1;

void gen_ax(int x)
{
c9:
    int b=rnd(65536);
    if notrange(b) goto c9;

    int c;
    for (;;)
    {
      b++;
      if ((b&0xFF)>C_MAX)
      {
        b=(b&0xFF00)+0x0100+C_MIN;
        if (b> ((C_MAX<<8)+C_MAX) ) break;
      }

      int t=((a-b)^x)&0xFF;
      for (c=C_MIN; c<=C_MAX; c++)
        if (!(t^c)) goto c1;
      continue;
c1:
      t=(((a-b)^x)>>8)&0xFF;
      int cc;
      for (cc=C_MIN; cc<=C_MAX; cc++)
        if (!(t^cc)) goto c2;
      continue;
c2:
      c|=cc<<8;

      goto c3;
    }

c0:
    a=rnd(65536);
    if notrange(a) goto c0;

    goto c9;

c3:

    int r = (a-b)^c;
    if ((r-x)&0xFFFF)
    {
      printf("x=%04X a=%04X b=%04X c=%04X r=%04X\n",x,a,b,c,r);
      printf("error\n");
      exit(0);
    }

    printf(".");

    if (a!=a0)
    {
      obuf[osize++]=0x68; // push a
      obuf[osize++]=a;
      obuf[osize++]=a>>8;
      crlf();

      obuf[osize++]=0x58; // pop ax
      crlf();
    }

    obuf[osize++]=0x2D; // sub ax, b
    obuf[osize++]=b;
    obuf[osize++]=b>>8;
    crlf();

    obuf[osize++]=0x35; // xor ax, c
    obuf[osize++]=c;
    obuf[osize++]=c>>8;
    crlf();

    a = x;
    a0 = a;
}

void main(int argc, char* argv[])
{
  if (argc!=3)
  {
    printf("syntax: com2uuex infile outfile\n");
    return;
  }

  FILE *f = fopen(argv[1],"rb");
  assert(f!=NULL);
  int isize = filelength(fileno(f));
  printf(" reading %s, %i byte(s)\n", argv[1], isize);
  short* ibuf = (short*)malloc(isize);
  fread(ibuf, 1,isize, f);
  fclose(f);

  printf(" converting\n");

  crlf();
  obuf[osize++] = 0x60; // pusha
  crlf();

  for (int i=(isize+1)/2-1; i>=0; i--)
  {
    gen_ax(ibuf[i]);
    obuf[osize++]=0x50; // push ax
    crlf();
  }

  int osize0 = osize;
  int osizes = 16;
  int savea0 = a0;

c7:
//obuf[osize++]=0xCC;

  int i=osize + osizes;
  int i1=rnd(65536);
  gen_ax(0x100+i-i1);

  obuf[osize++]=0x50;   // push ax
  crlf();
  obuf[osize++]=0x5B;   // pop  bx
  crlf();

  gen_ax(i1);

  obuf[osize++]=0x50;   // push ax
  crlf();
  obuf[osize++]=0x5E;   // pop  si
  crlf();

c8:
  int i2=rnd(65536);
  if notrange(i2) goto c8;

  gen_ax(0xD0FF^i2);    // FF D0   CALL AX
  obuf[osize++]=0x50;   // push ax
  crlf();
  obuf[osize++]=0x5F;   // pop  di
  crlf();
  obuf[osize++]=0x54;   // push sp
  crlf();
  obuf[osize++]=0x58;   // pop  ax
  crlf();

  obuf[osize++]=0x31;   // xor  [bx+si], di
  obuf[osize++]=0x38;
  crlf();

  while (osize<i)
  {
    obuf[osize++]=0x41;  // inc bx
    crlf();
  }

  if (osize>i)
  {
    printf("r");
    osize = osize0;
    osizes += 8;
    a0 = savea0;
    goto c7;
  }

  obuf[osize++]=i2;     // call ax
  obuf[osize++]=i2>>8;
  crlf();

  printf("\n writing %s, %i byte(s)\n", argv[2], osize);

  f = fopen(argv[2],"wb");
  assert(f!=NULL);
  fwrite(obuf, 1,osize, f);
  fclose(f);

}
